CGAL 5.6.3 - STL Extensions for CGAL

Loading...
Searching...
No Matches
Modules | Classes | Macros | Typedefs | Functions
STL Extensions for CGAL Reference

##

Michael Hoffmann, Lutz Kettner, Sylvain Pion, and Ron Wein
CGAL is designed in the spirit of the generic programming paradigm to work together with the Standard Template Library (STL). This package provides non-geometric STL-like algorithms and datastructures that are not in the STL standard, as well as functions to change the failure behaviour of assertions.
Introduced in: CGAL 1.0
BibTeX: cgal:hkpw-se-25b
License: LGPL

## Classified Reference Pages

## Doubly-Connected List Managing Items in Place

- `CGAL::In_place_list<T,bool>`
- `CGAL::In_place_list_base<T>`

## Compact Container

- `CGAL::Compact_container<T, Allocator>`
- `CGAL::Compact_container_traits<T>`
- `CGAL::Compact_container_base`

## Multiset with Extended Functionality

- `CGAL::Multiset<Type,Compare,Allocator>`

## Generic Algorithms

- `CGAL::min_max_element`
- `CGAL::cpp98::random_shuffle`

## Iterators and Iterator/Circulator Adaptors

- `CGAL::Dispatch_output_iterator<V,O>`
- `CGAL::Dispatch_or_drop_output_iterator<V,O>`
- `CGAL::Emptyset_iterator`
- `CGAL::Oneset_iterator<T>`
- `CGAL::Insert_iterator<Container>`
- `CGAL::Counting_iterator<Iterator, Value>`
- `CGAL::N_step_adaptor<I,int N>`
- `CGAL::Filter_iterator<Iterator, Predicate>`
- `CGAL::Join_input_iterator_1<Iterator, Creator>`
- `CGAL::Inverse_index<IC>`
- `CGAL::Random_access_adaptor<IC>`
- `CGAL::Random_access_value_adaptor<IC,T>`

## Ranges

- `CGAL::Iterator_range`

## Projection Function Objects

- `CGAL::Identity<Value>`
- `CGAL::Dereference<Value>`
- `CGAL::Get_address<Value>`
- `CGAL::Cast_function_object<Arg, Result>`
- `CGAL::Project_vertex<Node>`
- `CGAL::Project_facet<Node>`
- `CGAL::Project_point<Node>`
- `CGAL::Project_normal<Node>`
- `CGAL::Project_plane<Node>`
- `CGAL::Project_next<Node>`
- `CGAL::Project_prev<Node>`
- `CGAL::Project_next_opposite<Node>`
- `CGAL::Project_opposite_prev<Node>`

## Creator Function Objects

- `CGAL::Creator_1<Arg, Result>`
- `CGAL::Creator_2<Arg1, Arg2, Result>`
- `CGAL::Creator_3<Arg1, Arg2, Arg3, Result>`
- `CGAL::Creator_4<Arg1, Arg2, Arg3, Arg4, Result>`
- `CGAL::Creator_5<Arg1, Arg2, Arg3, Arg4, Arg5, Result>`
- `CGAL::Creator_uniform_2<Arg, Result>`
- `CGAL::Creator_uniform_3<Arg, Result>`
- `CGAL::Creator_uniform_4<Arg, Result>`
- `CGAL::Creator_uniform_5<Arg, Result>`
- `CGAL::Creator_uniform_6<Arg, Result>`
- `CGAL::Creator_uniform_7<Arg, Result>`
- `CGAL::Creator_uniform_8<Arg, Result>`
- `CGAL::Creator_uniform_9<Arg, Result>`
- `CGAL::Creator_uniform_d<Arg, Result>`

## Utilities

- `CGAL::Twotuple<T>`
- `CGAL::Threetuple<T>`
- `CGAL::Fourtuple<T>`
- `CGAL::Sixtuple<T>`
- `CGAL::Triple<T1, T2, T3>`
- `CGAL::Quadruple<T1, T2, T3, T4>`
- `CGAL::Boolean_tag<bool value>`
- `CGAL::Tag_true`
- `CGAL::Tag_false`
- `CGAL::Null_tag`
- `CGAL::Null_functor`
- `CGAL::Sequential_tag`
- `CGAL::Parallel_tag`
- `CGAL::Parallel_if_available_tag`
- `CGAL::Uncertain<T>`
- `CGAL::Default`
- `CGAL::Fast`
- `CGAL::Compact`
- `CGAL::Location_policy<Tag>`
- `CGAL::Fast_location`
- `CGAL::Compact_location`
- `CGAL::value_type_traits<T>`
- `CGAL::parameters::Default_named_parameters`
- `CGAL::parameters::default_values()`

## Modules
| Generic Algorithms
| Compact Container
| Projection Function Objects
| Creator Function Objects
| Doubly-Connected List Managing Items in Place
| Iterators and Iterator/Circulator Adaptors
| Concepts
| Utilities
| Assertions and Failure Behaviour

## Classes
class | CGAL::CC_safe_handle< CC_iterator >
| The class `CC_safe_handle` is a helper class that stores an iterator on a `Compact_container` (or `Concurrent_compact_container`) and is able to know if the pointee has been erased after the creation of the `CC_safe_handle` instance. More...
struct | CGAL::Concurrent_compact_container_traits< T >
| The traits class `Concurrent_compact_container_traits` provides the way to access the internal pointer required for `T` to be used in a `Concurrent_compact_container<T, Allocator>`. More...
struct | CGAL::Default
| `Default` is a tag class. More...
class | CGAL::Iterator_range< I >
| `CGAL::Iterator_range` encapsulates two iterators so they fulfill the `ForwardRange` concept. More...
class | CGAL::Multiset< Type, Compare, Allocator >
| More...
class | CGAL::Object
| Some functions can return different types of objects. More...
struct | CGAL::cpp11::result_of< F >
| Alias to the implementation of the `std::result_of` mechanism. More...
class | CGAL::Spatial_lock_grid_3< Grid_lock_tag >
| The class `Spatial_lock_grid_3` allows to lock points with coordinates (x, y, z) in a 3D grid. More...
struct | CGAL::value_type_traits< T >
| Class providing the value type of an iterator, and in the case of an output iterator, a type of objects that can be put in it. More...

## Macros
#define | CGAL_ALLOCATOR(T) std::allocator< T >
| A define for the allocator used by CGAL.

## Typedefs
typedef unspecified_type | CGAL::parameters::Default_named_parameters
| Type of the default named parameter pack.

## Functions
template<class T >
std::array< T, N > | CGAL::make_array (const T &...)
Default_named_parameters | CGAL::parameters::default_values ()
| returns a default named parameter type indicating that default values should be used.

## Macro Definition Documentation

## ◆ CGAL_ALLOCATOR

#define CGAL_ALLOCATOR | ( |  | T | ) | std::allocator< T >

`#include <CGAL/memory.h>`

A define for the allocator used by CGAL.

This is only defined if there is no user defined version before `memory.h` is included the first time.

## Function Documentation

## ◆ make_array()

template<class T >

std::array< T, N > CGAL::make_array | ( | const T & | ... | ) |

`#include <CGAL/array.h>`

Returns
  `std::array<T, N>` where `N` is the number of arguments given to the function. The position of each argument in the array is the same as its position in the argument list.

The maximal number of arguments is `6`.